/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.jiuqi.util.Stream
 *  com.jiuqi.util.StreamException
 */
package com.jiuqi.grid;

import com.jiuqi.util.Stream;
import com.jiuqi.util.StreamException;
import java.io.Serializable;

public class BitList
implements Serializable {
    private byte[] bits = null;
    private int count = 0;
    private boolean defaultValue;

    public BitList(boolean dftValue) {
        this.defaultValue = dftValue;
    }

    private void setCount(int c) {
        if (c >= 0) {
            int l;
            int n = l = this.bits == null ? 0 : this.bits.length;
            if (l * 8 >= c) {
                this.count = c;
                return;
            }
            l = (c - 1) / 8 + 1;
            if (this.bits != null) {
                byte[] nb = new byte[l];
                System.arraycopy(this.bits, 0, nb, 0, this.bits.length);
                this.bits = nb;
            } else {
                this.bits = new byte[l];
            }
            this.count = c;
        }
    }

    public void add(boolean value) {
        this.setCount(this.count() + 1);
        this.set(this.count - 1, value);
    }

    public boolean get(int index) {
        if (index >= 0 && index < this.count) {
            int b = index / 8;
            int p = index % 8;
            return (this.bits[b] >> p & 1) > 0;
        }
        return false;
    }

    public void set(int index, boolean value) {
        if (this.count <= index) {
            this.setCount(index + 1);
        }
        int b = index / 8;
        int p = index % 8;
        this.bits[b] = value ? (byte)(this.bits[b] | 1 << p) : (byte)(this.bits[b] & ~(1 << p));
    }

    public void insert(int index, int insCount) {
        if (index >= 0 && index <= this.count) {
            this.setCount(this.count + insCount);
            int i = this.count - 1;
            while (i >= index + insCount) {
                this.set(i, this.get(i - insCount));
                --i;
            }
            i = index;
            while (i < index + insCount) {
                this.set(i, this.defaultValue);
                ++i;
            }
        }
    }

    public void insert(int index, int insCount, boolean value) {
        if (index >= 0 && index <= this.count) {
            this.setCount(this.count + insCount);
            int i = this.count - 1;
            while (i >= index + insCount) {
                this.set(i, this.get(i - insCount));
                --i;
            }
            i = index;
            while (i < index + insCount) {
                this.set(i, value);
                ++i;
            }
        }
    }

    public void delete(int index, int delCount) {
        if (index >= 0 && index < this.count) {
            if (index + delCount > this.count) {
                delCount = this.count - index;
            }
            int i = index;
            while (i < this.count - delCount) {
                this.set(i, this.get(i + delCount));
                ++i;
            }
            this.setCount(this.count - delCount);
        }
    }

    public int count() {
        return this.count;
    }

    public void saveToStream(Stream stream) throws StreamException {
        if (this.count() > 0) {
            stream.writeBuffer(this.bits, 0, (this.count() - 1) / 8 + 1);
        }
    }

    public void loadFromStream(Stream stream, int size) throws StreamException {
        if (size > 0) {
            this.bits = new byte[size];
            stream.readBuffer(this.bits, 0, size);
            this.count = size * 8;
        } else {
            this.setCount(0);
            this.bits = null;
        }
    }
}

